#!/usr/bin/python3

import os.path
from os.path import *

import json

# définition  de la classe personne
class Personne():                            
  
    def __init__(self,nom,prenom,metier,age):
        self.nom = nom
        self.prenom = prenom
        self.metier = metier
        self.age = age
        
    def presentation(self):                 
        print("Bonjour, je m'appelle "+self.prenom+" "+self.nom+", j'ai "+str(self.age)+ " ans et je suis "+self.metier)
        
    def resume(self, n):
        print(str(n)+" : "+self.prenom+" "+self.nom+", "+str(self.age)+ " ans, "+self.metier)

# fonction de sérialisation d'un objet, pour son écriture sur le disque au format json
def serialiseur(obj):                  
    return {"__class__":"Personne",
        "nom":obj.nom,
        "prenom":obj.prenom,
        "metier":obj.metier,
        "age":obj.age}

# fonction de désérialisation d'un objet, pour sa lecture sur le disque au format json
def deserialiseur(objet):                   
    p = Personne(objet["nom"], objet["prenom"], objet["metier"], objet["age"])
    return p
  
# fonction de création d'une nouvelle personne par entrée des informations au clavier  
def nouvellePersonne():                         
    nom = input("nom : ")
    prenom = input("prenom : ")
    strage = input("age : ")
    metier = input("metier : ")
    age = int(strage)
    p = Personne(nom, prenom, metier, age) 
    return p
  
# debut du programme  
  
if os.path.isfile("personnes.json"):                               
    fichier = open("personnes.json","r")                               
    liste = json.load(fichier, object_hook = deserialiseur)
    fichier.close()
else:
    liste = []
    
action = "r"     # action sans effet pour rentrer dans la boucle 
while action != "q":    
    action = input("Que voulez-vous faire (a : ajouter une personne, s : supprimer une personne, v : voir les personnes, q : quitter)")
    if action == "a":
        p = nouvellePersonne()
        liste.append(p)
    if action == "v":
        for p in liste:
            p.resume(liste.index(p)+1)                           # on donne en parametre le numéro de la personne dans la liste
    if action == "s":                                            # cette fonction pose des problèmes dans le cas ou plusieures personnes ont le même nom, elle supprimeras la dernière de la liste
        n = input("numéro de la personne à supprimer : ")
        del liste[int(n)-1]                                      # attention au décalage de l'index
            
# écriture des informations sur le disque avant de quitter
fichier = open("personnes.json","w")  
json.dump(liste, fichier, default = serialiseur, indent = 2)
fichier.close()
            

        